
!UiAbstractItemView methodsFor: 'rows/columns - alignment' stamp: 'mt 10/14/2010 19:16:51.554'!
setHAlignmentForColumn: anIndex to: aSymbol

	(self viewport columnAt: anIndex)
		hAlignment: aSymbol.
		
	self updateLayout.! !

!UiAbstractItemView methodsFor: 'rows/columns - alignment' stamp: 'mt 10/14/2010 19:16:57.155'!
setVAlignmentForColumn: anIndex to: aSymbol

	(self viewport columnAt: anIndex)
		vAlignment: aSymbol.
		
	self updateLayout.! !

UiAbstractItemView subclass: #UiListIconView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiListIconView commentStamp: 'mt 10/14/2010 15:39:41.542' prior: 0!
I am a list view that is able to break the line of items in one direction and shows as many items as possible.!

!UiListIconView methodsFor: 'geometry' stamp: 'mt 10/14/2010 17:27:16.269'!
extent: aPoint

	super extent: aPoint.
	
	self viewport ifNotNil: [:v |
		v orientation = #default
			ifTrue: [v updateExtent]
			ifFalse: [v updateLayout]].! !

!UiListIconView methodsFor: 'model access' stamp: 'mt 10/14/2010 17:28:02.87'!
fillViewportFor: aModelIndex animated: aBoolean

	| index item |
	self model ifNil: [^ self].
	
	1 to: (self model rowCountFor: nil) do: [:row |
		index := self model indexRow: row column: 1 parent: nil.
		item := (self itemDelegateFor: index) itemFor: index.
		self viewport addMorph: item atIndex: index.
		aBoolean ifTrue: [item fadeIn]].! !

!UiListIconView methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:19:09.581'!
hAlignment: aSymbol

	self setHAlignmentForColumn: 1 to: aSymbol.! !

!UiListIconView methodsFor: 'initialization' stamp: 'mt 10/14/2010 17:27:39.015'!
initialize

	super initialize.
	
	self defaultItemDelegate: UiSimpleItemDelegate new.! !

!UiListIconView methodsFor: 'accessing' stamp: 'mt 10/14/2010 18:37:15.275'!
listOrientation: aSymbol
	"#default ... no breaks, horzintal scrolling if needed, full row selection
	#vertical ... items go from left to right and break at width -> vertical scrolling
	#horizontal ... items go from top to bottom and break at height -> horizontal scrolling"

	self listOrientation = aSymbol
		ifTrue: [^ self].
	
	self viewport orientation: aSymbol.
	self updateLayout.! !

!UiListIconView methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:19:17.877'!
vAlignment: aSymbol

	self setVAlignmentForColumn: 1 to: aSymbol.! !

Object subclass: #UiViewInfo
	instanceVariableNames: 'size items resizeMode headerItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

UiViewInfo subclass: #UiViewColumnInfo
	instanceVariableNames: 'vAlignment hAlignment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiViewColumnInfo commentStamp: 'mt 10/9/2010 11:38:45.048' prior: 0!
Useful index element for tree viewport.!

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:25.869'!
hAlignment

	^ hAlignment! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:34.152'!
hAlignment: aSymbol

	hAlignment := aSymbol.! !

!UiViewColumnInfo methodsFor: 'initialization' stamp: 'mt 10/14/2010 19:08:54.097'!
initialize

	super initialize.
	self
		resize: 150;
		vAlignment: #top;
		hAlignment: #left.! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:11.098'!
vAlignment

	^ vAlignment! !

!UiViewColumnInfo methodsFor: 'accessing' stamp: 'mt 10/14/2010 19:08:17.674'!
vAlignment: aSymbol

	vAlignment := aSymbol.! !

!UiViewRowInfo methodsFor: 'initialization' stamp: 'mt 10/14/2010 18:47:11.649'!
initialize

	super initialize.
	self resize: Preferences standardListFont height.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 10/14/2010 19:19:54.048'!
ex01iconicList

	UiListIconView new
		listOrientation: #vertical;
		defaultItemDelegate: (UiSimpleItemDelegate new orientation: #vertical);
		hAlignment: #center;
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 10/14/2010 17:59:12.416'!
ex02tree

	UiTreeView new
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 10/14/2010 19:23:15.693'!
ex03table

	UiTableView new
		setHAlignmentForColumn: 2 to: #right;
		setHAlignmentForColumn: 3 to: #center;
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 10/14/2010 19:28:40.411'!
ex04simpleList

	UiListIconView new
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiSmalltalkModel class methodsFor: 'examples' stamp: 'mt 10/14/2010 19:29:45.034'!
ex05horizontalList

	UiListIconView new
		listOrientation: #horizontal;
		model: UiSmalltalkModel new;
		topLeft: 50@50;
		extent: 600@300;
		openInWorld.! !

!UiListIconViewport methodsFor: 'rows/columns - to pixel' stamp: 'mt 10/14/2010 17:21:49.457'!
cellBoundsFor: aCellIndex

	self orientation = #default
		ifTrue: [^ super cellBoundsFor: aCellIndex].

	^ (((aCellIndex - (1@1)) * maxItemExtent) + self topLeft)
		extent: maxItemExtent! !

!UiListIconViewport methodsFor: 'rows/columns - to cell' stamp: 'mt 10/14/2010 17:18:49.01'!
cellIndexFromPoint: aPoint
	"Given a point in pixel coordinates."
	
	| cell |
	self orientation = #default ifTrue: [
		| offset |
		offset := self topLeft.
		rows withIndexDo: [:rowInfo :rowIndex | 
			((offset extent: self width @ rowInfo height) containsPoint: aPoint)
				ifTrue: [^ 1 @ rowIndex].
			offset := offset translateBy: 0 @ rowInfo height].
	
		^ nil].
	
	cell := ((aPoint - self topLeft) // (maxItemExtent)) + (1@1).
	
	self orientation = #vertical
		ifTrue: [
			(cell x > self maxItemsPerLine
				or: [cell y - 1 * self maxItemsPerLine + cell x > rows size])
				ifTrue: [^ nil]]
		ifFalse: [
			(cell y > self maxItemsPerLine
				or: [cell x - 1 * self maxItemsPerLine + cell y > rows size])
				ifTrue: [^ nil]].
	
	^ cell! !

!UiListIconViewport methodsFor: 'drawing' stamp: 'mt 10/14/2010 17:21:08.76'!
drawSubmorphsOn: aCanvas 
	
	self orientation = #default
		ifTrue: [^ super drawSubmorphsOn: aCanvas].
		
	submorphs isEmpty ifTrue: [^self].	
	aCanvas
		clipBy: self clippingBounds
		during: [:canvas | submorphs reverseDo: [:m | canvas fullDrawMorph: m]]! !

!UiListIconViewport methodsFor: 'initialization' stamp: 'mt 10/14/2010 17:19:17.313'!
initialize

	super initialize.
	self orientation: #default.! !

!UiListIconViewport methodsFor: 'rows/columns - to model index' stamp: 'mt 10/14/2010 17:25:43.136'!
modelIndexFor: aCellIndex

	self orientation = #default
		ifTrue: [^ super modelIndexFor: aCellIndex].

	aCellIndex ifNil: [^ nil].
	
	^ self orientation = #vertical
		ifTrue: [rows at: aCellIndex y - 1 * self maxItemsPerLine + aCellIndex x]
		ifFalse: [rows at: aCellIndex x - 1 * self maxItemsPerLine + aCellIndex y]! !

!UiListIconViewport methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:21:19.074'!
orientation

	^ orientation! !

!UiListIconViewport methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:30:02.272'!
orientation: aSymbol
	"#vertical ... items go from left to right and break at width -> vertical scrolling
	#horizontal ... items go from top to bottom and break at height -> horizontal scrolling"

	aSymbol = orientation ifTrue: [^ self].
	orientation := aSymbol.
	
	orientation = #default
		ifTrue: [self selectionBehavior: #selectRows]
		ifFalse: [self selectionBehavior: #selectCells].! !

!UiListIconViewport methodsFor: 'geometry' stamp: 'mt 10/14/2010 17:24:47.645'!
updateExtent

	self orientation = #default ifTrue: [
		| newHeight optimalWidth |	
		newHeight := rows
			ifEmpty: [0]
			ifNotEmpty: [(rows collect: [:row | row height]) sum].
	
		optimalWidth := columns first optimalSize.
	
		^ optimalWidth < self owner width
			ifTrue: [self extent: self owner width - 5 @ newHeight]
			ifFalse: [self extent: optimalWidth @ newHeight]].
		
	self extent: (((self submorphBounds extent / maxItemExtent) ceiling * maxItemExtent)
		max: (self owner extent - 5)).! !

!UiListIconViewport methodsFor: 'layouting' stamp: 'mt 10/14/2010 19:20:50.681'!
updateLayout

	| offset hAlignment |
	self orientation = #default
		ifTrue: [^ super updateLayout].	
	
	columns ifEmpty: [^ self].
	
	maxItemExtent := 1@1.
	columns first items do: [:item | maxItemExtent := maxItemExtent max: item extent].

	offset := self topLeft.
	hAlignment := columns first hAlignment.
	self rowsDo: [:rowInfo | | item |
		item := rowInfo items first.
		
		hAlignment = #left
			ifTrue: [item topLeft: offset].
		hAlignment = #center
			ifTrue: [item topLeft: offset + ((maxItemExtent x - item width)//2 @0)].
		hAlignment = #right
			ifTrue: [item topRight: offset + (maxItemExtent x @ 0)].

		self orientation = #vertical
			ifTrue: [
				offset := offset + (maxItemExtent x @ 0).
				(offset x + maxItemExtent x)  > (self owner width - 5)
					ifTrue: [offset := self left @ (offset y + maxItemExtent y)]]
			ifFalse: [
				offset := offset + (0 @ maxItemExtent y).
				(offset y + maxItemExtent y)  > (self owner height - 5)
					ifTrue: [offset := (offset x + maxItemExtent x) @ self top]]].
		
	self updateExtent.		! !

UiAbstractItemDelegate subclass: #UiSimpleItemDelegate
	instanceVariableNames: 'orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Widgets-Views'!

!UiSimpleItemDelegate methodsFor: 'layouting - private' stamp: 'mt 10/14/2010 17:59:39.564'!
doLayoutFor: aMorph

	| offset |
	self orientation = #horizontal ifTrue: [
		aMorph height: aMorph submorphs last height. "for smaller items use font height"
		
		"Manual layouting."
		offset := aMorph left + 3.
		aMorph submorphs do: [:m |
			m left: offset.
			offset := offset + m width + 2.
			m top: (aMorph top - (m height - aMorph height // 2))].
	
		"Expand item horizontally to its contents."
		aMorph
			width: aMorph submorphBounds width + 10; "font rendering bugfix"
			height: aMorph height + 1. "font rendering bugfix"
		
		^ self].
	
	self orientation = #vertical ifTrue: [
		aMorph width: aMorph submorphs last width + 10.
			
		"Manual layouting."
		offset := aMorph top + 3.
		aMorph submorphs do: [:m |
			m top: offset.
			offset := offset + m height + 2.
			m left: (aMorph left - (m width - aMorph width // 2))].
	
		aMorph height: aMorph submorphBounds height + 2].! !

!UiSimpleItemDelegate methodsFor: 'building' stamp: 'mt 10/14/2010 17:43:36.69'!
itemFor: aModelIndex

	| icon text item textMorph |
	icon := aModelIndex icon "ifNil: [Morph new extent: 16@16; color: Color transparent]".
	text := (aModelIndex text ifNil: [' ']) asText.
	
	textMorph := text asMorph lock.
	
	item := Morph new color: Color transparent.
	
	icon ifNotNil: [item addMorphBack: icon asMorph].
	item addMorphBack: textMorph.
	
	"Store morphs in properties for later access."
	item
		setProperty: #text toValue: text;
		setProperty: #icon toValue: icon.

	self doLayoutFor: item.	

	^ item! !

!UiSimpleItemDelegate methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:38:35.066'!
orientation

	^ orientation ifNil: [orientation := #horizontal]! !

!UiSimpleItemDelegate methodsFor: 'accessing' stamp: 'mt 10/14/2010 17:38:23.964'!
orientation: aSymbol
	"#vertical, #horizontal"

	 orientation := aSymbol.! !

!UiItemViewport methodsFor: 'rows/columns - to info' stamp: 'mt 10/14/2010 19:27:25.658'!
columnAt: index

	index > columns size
		ifTrue: [index - columns size timesRepeat: [columns add: UiViewColumnInfo new]].
	
	^ columns at: index! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/14/2010 19:13:50.564'!
updateColumnsLayout

	| offset |
	columns withIndexDo: [:colInfo :colIndex |
		offset := 0.
		colInfo items withIndexDo: [:item :rowIndex |
			| height |
			height := (rows at: rowIndex) height.
			colInfo vAlignment = #top
				ifTrue: [item top: offset].
			colInfo vAlignment = #center
				ifTrue: [item top: offset + (height - item height // 2)].
			colInfo vAlignment = #bottom
				ifTrue: [item bottom: offset + height].
							
			offset := offset + height]].! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/14/2010 19:23:37.085'!
updateLayout

	columns ifEmpty: [^ self].
	
	columns do: [:column | column updateSize].
	rows do: [:row | row updateSize].
	
	self updateColumnsLayout.
	self updateRowsLayout.
	
	columns first items do: [:item |
		item left: self left + (item valueOfProperty: #indent)].

	"Relayout changed header items."
	self horizontalHeader ifNotNil: [:hh |
		hh removeAllMorphs.
		columns do: [:colInfo | hh addMorphBack: colInfo headerItem]].
	self verticalHeader ifNotNil: [:vh |
		vh removeAllMorphs.
		rows do: [:rowInfo | vh addMorphBack: rowInfo headerItem]].
	
	"Shrink wrap to contents."
	self updateExtent.! !

!UiItemViewport methodsFor: 'layouting' stamp: 'mt 10/14/2010 19:13:41.424'!
updateRowsLayout

	| offset |
	self rowsDo: [:rowInfo |
		offset := 0.
		rowInfo items withIndexDo: [:item :colIndex |
			| width hAlignment |
			width := (columns at: colIndex) width.
			hAlignment := (columns at: colIndex) hAlignment.
			hAlignment = #left
				ifTrue: [item left: offset].
			hAlignment = #center
				ifTrue: [item left: offset + (width - item width // 2)].
			hAlignment = #right
				ifTrue: [item right: offset + width].
			
			offset := offset + width]].! !
